/*
 *  Hacker Disassembler Engine 32
 *  Copyright (c) 2006-2008, Veacheslav Patkov
 *  aLL rights reserved.
 *
 *  hde32.h : C/C++ header file
 *
 */

#ifndef _HDE_H_
#define _HDE_H_

#pragma pack(push,1)

typedef struct {
    unsigned char len;       /* length of command                             */
    unsigned char p_rep;     /* rep/repz (0xf3) & repnz (0xf2) prefix         */
    unsigned char p_lock;    /* lock prefix: 0xf0                             */
    unsigned char p_seg;     /* segment prefix: 0x2e,0x36,0x3e,0x26,0x64,0x65 */
    unsigned char p_66;      /* operand-size override prefix: 0x66            */
    unsigned char p_67;      /* address-size override prefix: 0x67            */
    unsigned char opcode;    /* opcode                                        */
    unsigned char opcode2;   /* second opcode (if first opcode is 0x0f)       */
    unsigned char modrm;     /* ModR/M byte                                   */
    unsigned char modrm_mod; /*   mod field of ModR/M                         */
    unsigned char modrm_reg; /*   reg field of ModR/M                         */
    unsigned char modrm_rm;  /*   r/m field of ModR/M                         */
    unsigned char sib;       /* SIB byte                                      */
    unsigned char sib_scale; /*   scale field of SIB                          */
    unsigned char sib_index; /*   index field of SIB                          */
    unsigned char sib_base;  /*   base field of SIB                           */
    unsigned char imm8;      /* immediate value imm8                          */
    unsigned short imm16;    /* immediate value imm16                         */
    unsigned long imm32;     /* immediate value imm32                         */
    unsigned char disp8;     /* displacement disp8                            */
    unsigned short disp16;   /* displacement disp16                           */
    unsigned long disp32;    /* displacement disp32                           */
    unsigned char rel8;      /* relative address rel8                         */
    unsigned short rel16;    /* relative address rel16                        */
    unsigned long rel32;     /* relative address rel32                        */
} hde32s;

#pragma pack(pop)

#ifdef __cplusplus
extern "C" {
#endif

unsigned int __cdecl hde32_disasm(const void *code, hde32s *hs);

#ifdef __cplusplus
}
#endif

#endif /* _HDE_H_ */
