;
;  Hacker Disassembler Engine 32
;  Copyright (c) 2006-2008, Veacheslav Patkov
;  aLL rights reserved.
;
;  hde32.inc : masm/tasm header file
;

hde32_disasm proto c :dword, :dword

hde32s struct
    len        db ?   ; length of command
    p_rep      db ?   ; rep/repz (0xf3) & repnz (0xf2) prefix 
    p_lock     db ?   ; lock prefix: 0xf0
    p_seg      db ?   ; segment prefix: 0x2e,0x36,0x3e,0x26,0x64,0x65
    p_66       db ?   ; operand-size override prefix: 0x66
    p_67       db ?   ; address-size override prefix: 0x67
    opcode     db ?   ; opcode
    opcode2    db ?   ; second opcode (if first opcode is 0x0f)
    modrm      db ?   ; ModR/M byte
    modrm_mod  db ?   ;   mod field of ModR/M
    modrm_reg  db ?   ;   reg field of ModR/M
    modrm_rm   db ?   ;   r/m field of ModR/M
    sib        db ?   ; SIB byte
    sib_scale  db ?   ;   scale field of SIB
    sib_index  db ?   ;   index field of SIB
    sib_base   db ?   ;   base field of SIB
    imm8       db ?   ; immediate value imm8
    imm16      dw ?   ; immediate value imm16
    imm32      dd ?   ; immediate value imm32
    disp8      db ?   ; displacement disp8
    disp16     dw ?   ; displacement disp16
    disp32     dd ?   ; displacement disp32
    rel8       db ?   ; relative address rel8
    rel16      dw ?   ; relative address rel16
    rel32      dd ?   ; relative address rel32
hde32s ends
