;
;  Hacker Disassembler Engine 32
;  Copyright (c) 2006-2008, Veacheslav Patkov.
;  aLL rights reserved.
;

%define C_NONE   0x00
%define C_MODRM  0x01
%define C_DATA8  0x02
%define C_DATA16 0x04
%define C_DATA32 0x08
%define C_PRE66  0x10
%define	C_REL8   0x20
%define C_REL32  0x40

struc hde32s
    .len        resb 1   ; length of command
    .p_rep      resb 1   ; rep/repz (0xf3) & repnz (0xf2) prefix
    .p_lock     resb 1   ; lock prefix: 0xf0
    .p_seg      resb 1   ; segment prefix: 0x2e,0x36,0x3e,0x26,0x64,0x65
    .p_66       resb 1   ; operand-size override prefix: 0x66
    .p_67       resb 1   ; address-size override prefix: 0x67
    .opcode     resb 1   ; opcode
    .opcode2    resb 1   ; second opcode (if first opcode is 0x0f)
    .modrm      resb 1   ; ModR/M byte:
    .modrm_mod  resb 1   ;   mod field of ModR/M
    .modrm_reg  resb 1   ;   reg field of ModR/M
    .modrm_rm   resb 1   ;   r/m field of ModR/M
    .sib        resb 1   ; SIB byte:
    .sib_scale  resb 1   ;   scale field of SIB
    .sib_index  resb 1   ;   index field of SIB
    .sib_base   resb 1   ;   base field of SIB
    .imm8       resb 1   ; immediate value imm8
    .imm16      resw 1   ; immediate value imm16
    .imm32      resd 1   ; immediate value imm32
    .disp8      resb 1   ; displacement disp8
    .disp16     resw 1   ; displacement disp16
    .disp32     resd 1   ; displacement disp32
    .rel8       resb 1   ; relative address rel8
    .rel16      resw 1   ; relative address rel16
    .rel32      resd 1   ; relative address rel32
endstruc

%define delta_table hde_table_ext-hde_table
