;
;  Hacker Disassembler Engine 32
;  Copyright (c) 2006-2008, Veacheslav Patkov.
;  aLL rights reserved.
;

cpu 386
bits 32

%ifidni __OUTPUT_FORMAT__,obj
  section _TEXT class=CODE use32 FLAT
%else
  section .text
%endif

%macro globals 1
  global %1
  global _%1
  %1:
  _%1:
%endmacro

%include "hde32.ash"

globals hde32_disasm
	pushad
	mov	edi,[esp+40]
	xor	eax,eax
	xor	ecx,ecx
	xor	ebx,ebx
	cdq
	mov	cl,hde32s_size
	rep	stosb
	sub	edi,byte hde32s_size
	mov	esi,[esp+36]
      pref:
	lodsb
	cmp	al,0xf3
	jz	pref_rep
	cmp	al,0xf2
	jnz	no_pref_rep
      pref_rep:
	mov	[edi+hde32s.p_rep],al
	jmp	short pref
      no_pref_rep:
	cmp	al,0xf0
	jnz	no_pref_lock
	mov	[edi+hde32s.p_lock],al
	jmp	short pref
      no_pref_lock:
	cmp	al,0x2e
	jz	pref_seg
	cmp	al,0x36
	jz	pref_seg
	cmp	al,0x3e
	jz	pref_seg
	cmp	al,0x26
	jz	pref_seg
	cmp	al,0x64
	jz	pref_seg
	cmp	al,0x65
	jnz	no_pref_seg
      pref_seg:
	mov	[edi+hde32s.p_seg],al
	jmp	short pref
      no_pref_seg:
	cmp	al,0x66
	jnz	no_pref_66
	mov	[edi+hde32s.p_66],al
	mov	dl,1
	jmp	short pref
      no_pref_66:
	cmp	al,0x67
	jnz	no_pref_67
	mov	[edi+hde32s.p_67],al
	mov	bl,1
	jmp	short pref
      no_pref_67:
	mov	[edi+hde32s.opcode],al
	mov	bh,al
	call	get_delta
      get_delta:
	pop	ecx
	add	ecx,hde_table-get_delta
	cmp	al,0x0f
	jnz	no_opcode2
	lodsb
	mov	[edi+hde32s.opcode2],al
	add	ecx,byte delta_table
	jmp	short modrm
      no_opcode2:
	cmp	al,0xa0
	jb	modrm
	cmp	al,0xa3
	ja	modrm
	mov	dl,bl
      modrm:
	mov	dh,al
	and	dh,3
	shr	al,2
	mov	al,[ecx+eax]
	add	al,dh
	mov	cl,[ecx+eax]
	test	cl,C_MODRM
	jz	near imm
	lodsb
	mov	[edi+hde32s.modrm],al
	mov	ch,al
	shr	ch,6
	mov	[edi+hde32s.modrm_mod],ch
	mov	dh,al
	and	dh,7
	mov	[edi+hde32s.modrm_rm],dh
	shl	al,2
	shr	al,5
	mov	[edi+hde32s.modrm_reg],al
	cmp	al,1
	lodsb
	ja	no_f7
	cmp	bh,0xf6
	jnz	no_f6
	or	cl,C_DATA8
      no_f6:
	cmp	bh,0xf7
	jnz	no_f7
	or	cl,C_PRE66
      no_f7:
	xor	bh,bh
	or	ch,ch
	jnz	no_mod_0
	or	bl,bl
	jz	no_p67
	cmp	dh,6
	jnz	no_mod_0
	mov	bh,2
	jmp	short no_mod_0
      no_p67:
	cmp	dh,5
	jnz	no_mod_0
	mov	bh,4
      no_mod_0:
	cmp	ch,1
	jnz	no_mod_1
	mov	bh,1
      no_mod_1:
	cmp	ch,2
	jnz	no_mod_2
	or	bl,bl
	jz	no_p67_
	mov	bh,2
	jmp	short no_mod_2
      no_p67_:
	mov	bh,4
      no_mod_2:
	cmp	ch,3
	jz	disp
	cmp	dh,4
	jnz	disp
	or	bl,bl
	jnz	disp
	inc	esi
	mov	[edi+hde32s.sib],al
	mov	ah,al
	shr	ah,6
	mov	[edi+hde32s.sib_scale],ah
	mov	ah,al
	shl	ah,2
	shr	ah,5
	mov	[edi+hde32s.sib_index],ah
	and	al,7
	mov	[edi+hde32s.sib_base],al
	cmp	al,5
	jnz	disp
	or	ch,ch
	jz	mod_0
	cmp	ch,2
	jnz	disp
      mod_0:
	mov	bh,4
      disp:
	dec	esi
	cmp	bh,1
	jnz	no_disp8
	lodsb
	mov	[edi+hde32s.disp8],al
      no_disp8:
	cmp	bh,2
	jnz	no_disp16
	lodsw
	mov	[edi+hde32s.disp16],ax
      no_disp16:
	cmp	bh,4
	jnz	imm
	lodsd
	mov	[edi+hde32s.disp32],eax
      imm:
	test	cl,C_PRE66
	jz	no_pre66
	test	cl,C_REL32
	jz	no_rel32
	or	dl,dl
	jz	no_p66
	lodsw
	mov	[edi+hde32s.rel16],ax
	jmp	short hde_dasm_end
      no_p66:
	lodsd
	mov	[edi+hde32s.rel32],eax
	jmp	short hde_dasm_end
      no_rel32:
	or	dl,dl
	jz	no_p66_
	lodsw
	mov	[edi+hde32s.imm16],ax
	jmp	short no_pre66
      no_p66_:
	lodsd
	mov	[edi+hde32s.imm32],eax
      no_pre66:
	test	cl,C_DATA32
	jz	no_imm32
	lodsd
	mov	[edi+hde32s.imm32],eax
      no_imm32:
	test	cl,C_DATA16
	jz	no_imm16
	lodsw
	mov	[edi+hde32s.imm16],ax
      no_imm16:
	test	cl,C_DATA8
	jz	no_imm8
	lodsb
	mov	[edi+hde32s.imm8],al
      no_imm8:
	test	cl,C_REL32
	jz	no_rel32_
	lodsd
	mov	[edi+hde32s.rel32],eax
      no_rel32_:
	test	cl,C_REL8
	jz	hde_dasm_end
	lodsb
	mov	[edi+hde32s.rel8],al
      hde_dasm_end:
	xchg	eax,esi
	sub	eax,[esp+36]
	stosb
	mov	[esp+28],eax
	popad
	ret

%include "table.ash"
